/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class Activities
   Method Init() constructor
   Method Find(caseid, activities, refdat)
   Method Get(id, activity, requestor, refdat)
   /* BEGIN */
   Method GetWorklist()
   Method QueryOnRappeltermExpired(cNameProcess, cNameActivity, aResultset, dRundate)
   Method QueryOnOpenActivities(cNameProcess, cNameActivity, aResultset)
   /* END */
endclass   

Method Init() class Activities
return self

Method Find(caseid, activities, refdat) class Activities
   local old := select(), obj := {}
   select 0
   use acti index actia 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(caseid, 10)
      do while .not. eof() .and. acti->CASEID = caseid
         aadd(activities, Activity():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(caseid, 10)
      do while .not. eof() .and. acti->CASEID = caseid
         obj := SaveRec(obj)
         DbfLogRollback("ACTI", acti->ID, refdat)
         if acti->DELETED == "N" .and. acti->INGDAT <= refdat 
            aadd(activities, Activity():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return activities
   
Method Get(id, activity, requestor, refdat) class Activities
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use ACTI index ACTI
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("ACTI", acti->ID, refdat)
         activity:Transfer()	
         RestRec(obj)
      else
         activity:Transfer()	
      endif
   endif
   if requestor != "old" 
      if requestor != "case"
         Cases():Get(acti->CASEID, activity:case, "activity", refdat)
      endif
      if requestor != "activityDefinition"
         ActivityDefinitions():Get(acti->DACTID, activity:activityDefinition, "activity", refdat)
      endif
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return activity

class Activity
   data id
   data dateStart
   data timeStart
   data dateEnd
   data timeEnd
   data abbrevActor
   data descrStatus
   data descrMessage
   data numberOfMonthsRecallterm
   data indicCurrent
   data case
   data activityDefinition
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class Activity
   self:id := 0
   self:dateStart := ctod("  -  -    ")
   self:timeStart := ""
   self:dateEnd := ctod("  -  -    ")
   self:timeEnd := ""
   self:abbrevActor := ""
   self:descrStatus := ""
   self:descrMessage := ""
   self:numberOfMonthsRecallterm := 0
   self:indicCurrent := ""
   self:case := Case():New()
   self:activityDefinition := ActivityDefinition():New()
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use acti index acti, actia, actib, actic
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = activities():Get(id, activity():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               acti->DELETED := self:deleted
               acti->USERID := userid
               acti->TXDATE := txdate
               acti->TXTIME := txtime
               delete
               unlock
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("ACTI")
         self:id = newId
         AddRec(1)	
         acti->ID := self:id
         /* BEGIN */
         acti->CASEID := self:case:id
         acti->DACTID := self:activityDefinition:id
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class Activity
local retval := .T.
   set exact on
   if self:dateStart != old_rec:dateStart
      retval := .F.
   endif
   if self:timeStart != old_rec:timeStart
      retval := .F.
   endif
   if self:dateEnd != old_rec:dateEnd
      retval := .F.
   endif
   if self:timeEnd != old_rec:timeEnd
      retval := .F.
   endif
   if self:abbrevActor != old_rec:abbrevActor
      retval := .F.
   endif
   if self:descrStatus != old_rec:descrStatus
      retval := .F.
   endif
   if self:descrMessage != old_rec:descrMessage
      retval := .F.
   endif
   if self:numberOfMonthsRecallterm != old_rec:numberOfMonthsRecallterm
      retval := .F.
   endif
   if self:indicCurrent != old_rec:indicCurrent
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class Activity
   self:id := acti->ID 	
   self:dateStart := acti->STARTDAT
   self:timeStart := rtrim(acti->STARTTIJD)
   self:dateEnd := acti->EINDDAT
   self:timeEnd := rtrim(acti->EINDTIJD)
   self:abbrevActor := rtrim(acti->BEHAND)
   self:descrStatus := rtrim(acti->STATUS)
   self:descrMessage := rtrim(acti->MESSAGE)
   self:numberOfMonthsRecallterm := acti->RAPPTERM
   self:indicCurrent := rtrim(acti->CURRIND)
   self:deleted := acti->DELETED 	
   self:userid := acti->USERID 	
   self:txdate := acti->TXDATE 	
   self:txtime := acti->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class Activity
   acti->STARTDAT := self:dateStart
   acti->STARTTIJD := self:timeStart
   acti->EINDDAT := self:dateEnd
   acti->EINDTIJD := self:timeEnd
   acti->BEHAND := self:abbrevActor
   acti->STATUS := self:descrStatus
   acti->MESSAGE := self:descrMessage
   acti->RAPPTERM := self:numberOfMonthsRecallterm
   acti->CURRIND := self:indicCurrent
   acti->DELETED := self:deleted
   acti->USERID := userid
   acti->TXDATE := txdate
   acti->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class Activity
   if self:dateStart != old_rec:dateStart
      DbfLogAdd(alias(), "STARTDAT", old_rec:id, dtoc(old_rec:dateStart), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:timeStart != old_rec:timeStart
      DbfLogAdd(alias(), "STARTTIJD", old_rec:id, old_rec:timeStart, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:dateEnd != old_rec:dateEnd
      DbfLogAdd(alias(), "EINDDAT", old_rec:id, dtoc(old_rec:dateEnd), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:timeEnd != old_rec:timeEnd
      DbfLogAdd(alias(), "EINDTIJD", old_rec:id, old_rec:timeEnd, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:abbrevActor != old_rec:abbrevActor
      DbfLogAdd(alias(), "BEHAND", old_rec:id, old_rec:abbrevActor, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrStatus != old_rec:descrStatus
      DbfLogAdd(alias(), "STATUS", old_rec:id, old_rec:descrStatus, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrMessage != old_rec:descrMessage
      DbfLogAdd(alias(), "MESSAGE", old_rec:id, old_rec:descrMessage, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:numberOfMonthsRecallterm != old_rec:numberOfMonthsRecallterm
      DbfLogAdd(alias(), "RAPPTERM", old_rec:id, str(old_rec:numberOfMonthsRecallterm), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:indicCurrent != old_rec:indicCurrent
      DbfLogAdd(alias(), "CURRIND", old_rec:id, old_rec:indicCurrent, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
/*
   specific queries 	
*/
Method GetWorklist() class Activities
   local old := select(), a, worklist := {}
   select 0
   use proc index proc
   select 0
   use dact index dact 		
   select 0
   use acti
   set relation to str(DACTID) into dact
   select("DACT")
   set relation to str(PROCID)into proc
   select("ACTI") 
   do while .not. eof()
	if (dact->BEHANDTEAM == userprofile:codeUserGroup ;
   	.and. empty(acti->BEHAND) ;
   	.and. AuthEval(dact->ROL) ;
   	.and. (dact->INDIC4OGEN = "N" .or. acti->USERID != userprofile:userid)) ;
   	.or. (acti->BEHAND == userprofile:userid .and. empty(acti->EINDDAT))
         a := Activity():New():Transfer()
	   /* note that a:case:id is only loaded via standard Get() */ 	
		 aadd(worklist, {a, proc->PROCOMS, acti->CASEID, dact->ACTOMS})
      endif 
      skip
   enddo
   use
   select("DACT")
   use
   select("PROC")
   use
   select(old) 
return(worklist)

Method QueryOnRappeltermExpired(cNameProcess, cNameActivity, aResultset, dRundate) class Activities
   local old := select(), txdate, oActivity
   if pcount() > 3
      txdate := dRundate
   else
      txdate := date()
   endif   
   select 0
   use proc index proc
   select 0
   use dact index dact 		
   set relation to str(PROCID)into proc
   select 0
   use case index case 		
   select 0
   use acti
   set relation to str(DACTID) into dact
   set relation to str(CASEID) into case additive
   do while .not. eof()
      if empty(acti->EINDDAT)
         if rtrim(proc->PROCOMS) == cNameProcess .and. rtrim(dact->ACTOMS) == cNameActivity
            if txdate >= (acti->STARTDAT + acti->RAPPTERM)
               oActivity := Activity():New():Transfer()
               aadd(aResultset, {oActivity, case->ID, case->REFID, dact->RAPPTERM})
             endif  
         endif   
      endif 
      skip
   enddo
   use
   select("CASE")
   use
   select("DACT")
   use
   select("PROC")
   use
   select(old)
return(aResultset)

Method QueryOnOpenActivities(cNameProcess, cNameActivity, aResultset) class Activities
   local old := select(), oActivity
   select 0
   use proc index proc
   select 0
   use dact index dact 		
   set relation to str(PROCID)into proc
   select 0
   use case index case 		
   select 0
   use acti
   set relation to str(DACTID) into dact
   set relation to str(CASEID) into case additive
   do while .not. eof()
      if empty(acti->EINDDAT)
         if rtrim(proc->PROCOMS) == cNameProcess .and. rtrim(dact->ACTOMS) == cNameActivity
            oActivity := Activity():New():Transfer()
            aadd(aResultset, {oActivity, case->ID})
         endif   
      endif 
      skip
   enddo
   use
   select("CASE")
   use
   select("DACT")
   use
   select("PROC")
   use
   select(old)
return(aResultset)
/* END */
