/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class Customers
   Method Init() constructor
   Method Find(custid, customers, refdat)
   Method Get(id, customer, requestor, refdat)
   /* BEGIN */
   Method QueryAll()
   Method QueryOnSearch(lastname, customerno, zipcode)
   /* END */
endclass   

Method Init() class Customers
return self

Method Find(custid, customers, refdat) class Customers
   local old := select(), obj := {}
   select 0
   use cust index custa 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(custid, 10)
      do while .not. eof() .and. cust->CUSTID = custid
         aadd(customers, Customer():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(custid, 10)
      do while .not. eof() .and. cust->CUSTID = custid
         obj := SaveRec(obj)
         DbfLogRollback("CUST", cust->ID, refdat)
         if cust->DELETED == "N" .and. cust->INGDAT <= refdat 
            aadd(customers, Customer():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return customers
   
Method Get(id, customer, requestor, refdat) class Customers
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use CUST index CUST
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("CUST", cust->ID, refdat)
         customer:Transfer()	
         RestRec(obj)
      else
         customer:Transfer()	
      endif
   endif
   if requestor != "old" 
      if requestor != "order"
         Orders():Find(id, customer:orders, refdat)
         for n := 1 to len(customer:orders)
            Orders():Get(customer:orders[n]:id, customer:orders[n], "customer", refdat)
         next
      endif
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return customer

class Customer
   data id
   data numberCustomer
   data nameFirst
   data nameLast
   data indicGender
   data dateBirth
   data numberTelephone
   data descrEmail
   data nameStreet
   data codeHouse
   data codeZip
   data nameCity
   data orders
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class Customer
   self:id := 0
   self:numberCustomer := 0
   self:nameFirst := ""
   self:nameLast := ""
   self:indicGender := ""
   self:dateBirth := ctod("  -  -    ")
   self:numberTelephone := ""
   self:descrEmail := ""
   self:nameStreet := ""
   self:codeHouse := ""
   self:codeZip := ""
   self:nameCity := ""
   self:orders := {}
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use cust index cust
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = customers():Get(id, customer():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               cust->DELETED := self:deleted
               cust->USERID := userid
               cust->TXDATE := txdate
               cust->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("CUST")
         self:id = newId
         AddRec(1)	
         cust->ID := self:id
         /* BEGIN */
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class Customer
local retval := .T.
   set exact on
   if self:numberCustomer != old_rec:numberCustomer
      retval := .F.
   endif
   if self:nameFirst != old_rec:nameFirst
      retval := .F.
   endif
   if self:nameLast != old_rec:nameLast
      retval := .F.
   endif
   if self:indicGender != old_rec:indicGender
      retval := .F.
   endif
   if self:dateBirth != old_rec:dateBirth
      retval := .F.
   endif
   if self:numberTelephone != old_rec:numberTelephone
      retval := .F.
   endif
   if self:descrEmail != old_rec:descrEmail
      retval := .F.
   endif
   if self:nameStreet != old_rec:nameStreet
      retval := .F.
   endif
   if self:codeHouse != old_rec:codeHouse
      retval := .F.
   endif
   if self:codeZip != old_rec:codeZip
      retval := .F.
   endif
   if self:nameCity != old_rec:nameCity
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class Customer
   self:id := cust->ID 	
   self:numberCustomer := cust->CUSTOMERNO
   self:nameFirst := rtrim(cust->FIRSTNAME)
   self:nameLast := rtrim(cust->LASTNAME)
   self:indicGender := rtrim(cust->GENDER)
   self:dateBirth := cust->BIRTHDATE
   self:numberTelephone := rtrim(cust->TELNO)
   self:descrEmail := rtrim(cust->EMAIL)
   self:nameStreet := rtrim(cust->STREET)
   self:codeHouse := rtrim(cust->HOUSENO)
   self:codeZip := rtrim(cust->ZIPCODE)
   self:nameCity := rtrim(cust->CITY)
   self:deleted := cust->DELETED 	
   self:userid := cust->USERID 	
   self:txdate := cust->TXDATE 	
   self:txtime := cust->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class Customer
   cust->CUSTOMERNO := self:numberCustomer
   cust->FIRSTNAME := self:nameFirst
   cust->LASTNAME := self:nameLast
   cust->GENDER := self:indicGender
   cust->BIRTHDATE := self:dateBirth
   cust->TELNO := self:numberTelephone
   cust->EMAIL := self:descrEmail
   cust->STREET := self:nameStreet
   cust->HOUSENO := self:codeHouse
   cust->ZIPCODE := self:codeZip
   cust->CITY := self:nameCity
   cust->DELETED := self:deleted
   cust->USERID := userid
   cust->TXDATE := txdate
   cust->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class Customer
   if self:numberCustomer != old_rec:numberCustomer
      DbfLogAdd(alias(), "CUSTOMERNO", old_rec:id, str(old_rec:numberCustomer), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameFirst != old_rec:nameFirst
      DbfLogAdd(alias(), "FIRSTNAME", old_rec:id, old_rec:nameFirst, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameLast != old_rec:nameLast
      DbfLogAdd(alias(), "LASTNAME", old_rec:id, old_rec:nameLast, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:indicGender != old_rec:indicGender
      DbfLogAdd(alias(), "GENDER", old_rec:id, old_rec:indicGender, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:dateBirth != old_rec:dateBirth
      DbfLogAdd(alias(), "BIRTHDATE", old_rec:id, dtoc(old_rec:dateBirth), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:numberTelephone != old_rec:numberTelephone
      DbfLogAdd(alias(), "TELNO", old_rec:id, old_rec:numberTelephone, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrEmail != old_rec:descrEmail
      DbfLogAdd(alias(), "EMAIL", old_rec:id, old_rec:descrEmail, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameStreet != old_rec:nameStreet
      DbfLogAdd(alias(), "STREET", old_rec:id, old_rec:nameStreet, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeHouse != old_rec:codeHouse
      DbfLogAdd(alias(), "HOUSENO", old_rec:id, old_rec:codeHouse, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeZip != old_rec:codeZip
      DbfLogAdd(alias(), "ZIPCODE", old_rec:id, old_rec:codeZip, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameCity != old_rec:nameCity
      DbfLogAdd(alias(), "CITY", old_rec:id, old_rec:nameCity, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
Method QueryAll() class Customers
   local old := select(), customers := {}
   select 0
   use cust  
   do while .not. eof()
      aadd(customers, Customer():New():Transfer()) 
      skip
   enddo
   use
   select(old)
return customers

Method QueryOnSearch(lastname, customerno, zipcode) class Customers
   local old := select(), customers := {}
   select 0
   use cust  
   do while .not. eof()
      if rtrim(cust->LASTNAME) = lastname ;
      .and. if(customerno > 0, cust->CUSTOMERNO = customerno, .T.) ;
      .and. rtrim(cust->ZIPCODE) = zipcode
         aadd(customers, Customer():New():Transfer()) 
      endif   
      skip
   enddo
   use
   select(old)
return customers
/* END */
