/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class Orders
   Method Init() constructor
   Method Find(custid, orders, refdat)
   Method Get(id, order, requestor, refdat)
   /* BEGIN */
   Method GetLatestSeqno(txdate)
   /* END */
endclass   

Method Init() class Orders
return self

Method Find(custid, orders, refdat) class Orders
   local old := select(), obj := {}
   select 0
   use ordr index ordra 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(custid, 10)
      do while .not. eof() .and. ordr->CUSTID = custid
         aadd(orders, Order():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(custid, 10)
      do while .not. eof() .and. ordr->CUSTID = custid
         obj := SaveRec(obj)
         DbfLogRollback("ORDR", ordr->ID, refdat)
         if ordr->DELETED == "N" .and. ordr->INGDAT <= refdat 
            aadd(orders, Order():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return orders
   
Method Get(id, order, requestor, refdat) class Orders
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use ORDR index ORDR
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("ORDR", ordr->ID, refdat)
         order:Transfer()	
         RestRec(obj)
      else
         order:Transfer()	
      endif
   endif
   if requestor != "old" 
      if requestor != "customer"
         Customers():Get(ordr->CUSTID, order:customer, "order", refdat)
      endif
      if requestor != "orderline"
         Orderlines():Find(id, order:orderlines, refdat)
         for n := 1 to len(order:orderlines)
            Orderlines():Get(order:orderlines[n]:id, order:orderlines[n], "order", refdat)
         next
      endif
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return order

class Order
   data id
   data numberOrder
   data dateDelivery
   data descrStatus
   data customer
   data orderlines
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class Order
   self:id := 0
   self:numberOrder := 0
   self:dateDelivery := ctod("  -  -    ")
   self:descrStatus := ""
   self:customer := Customer():New()
   self:orderlines := {}
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use ordr index ordr, ordra, ordrb
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = orders():Get(id, order():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               ordr->DELETED := self:deleted
               ordr->USERID := userid
               ordr->TXDATE := txdate
               ordr->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("ORDR")
         self:id = newId
         AddRec(1)	
         ordr->ID := self:id
         /* BEGIN */
      ordr->CUSTID := self:customer:id
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class Order
local retval := .T.
   set exact on
   if self:numberOrder != old_rec:numberOrder
      retval := .F.
   endif
   if self:dateDelivery != old_rec:dateDelivery
      retval := .F.
   endif
   if self:descrStatus != old_rec:descrStatus
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class Order
   self:id := ordr->ID 	
   self:numberOrder := ordr->ORDERNO
   self:dateDelivery := ordr->DELIVERY
   self:descrStatus := rtrim(ordr->STATUS)
   self:deleted := ordr->DELETED 	
   self:userid := ordr->USERID 	
   self:txdate := ordr->TXDATE 	
   self:txtime := ordr->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class Order
   ordr->ORDERNO := self:numberOrder
   ordr->DELIVERY := self:dateDelivery
   ordr->STATUS := self:descrStatus
   ordr->DELETED := self:deleted
   ordr->USERID := userid
   ordr->TXDATE := txdate
   ordr->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class Order
   if self:numberOrder != old_rec:numberOrder
      DbfLogAdd(alias(), "ORDERNO", old_rec:id, str(old_rec:numberOrder), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:dateDelivery != old_rec:dateDelivery
      DbfLogAdd(alias(), "DELIVERY", old_rec:id, dtoc(old_rec:dateDelivery), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrStatus != old_rec:descrStatus
      DbfLogAdd(alias(), "STATUS", old_rec:id, old_rec:descrStatus, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
Method GetLatestSeqno(txdate) class Orders
   local old := select(), nNumber := 0
   set deleted off
   select 0
   use ordr index ordrb 
   seek dtos(txdate)
   do while .not. eof() .and. ordr->DELIVERY = txdate
      nNumber++
      skip
   enddo
   use
   select(old)   
   set deleted on
return(nNumber)   
/* END */
