/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class Orderlines
   Method Init() constructor
   Method Find(ordrid, orderlines, refdat)
   Method Get(id, orderline, requestor, refdat)
   /* BEGIN */
   Method IsProductInUse(nProdId) 
   /* END */
endclass   

Method Init() class Orderlines
return self

Method Find(ordrid, orderlines, refdat) class Orderlines
   local old := select(), obj := {}
   select 0
   use orln index orlna 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(ordrid, 10)
      do while .not. eof() .and. orln->ORDRID = ordrid
         aadd(orderlines, Orderline():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(ordrid, 10)
      do while .not. eof() .and. orln->ORDRID = ordrid
         obj := SaveRec(obj)
         DbfLogRollback("ORLN", orln->ID, refdat)
         if orln->DELETED == "N" .and. orln->INGDAT <= refdat 
            aadd(orderlines, Orderline():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return orderlines
   
Method Get(id, orderline, requestor, refdat) class Orderlines
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use ORLN index ORLN
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("ORLN", orln->ID, refdat)
         orderline:Transfer()	
         RestRec(obj)
      else
         orderline:Transfer()	
      endif
   endif
   if requestor != "old" 
      if requestor != "order"
         Orders():Get(orln->ORDRID, orderline:order, "orderline", refdat)
      endif
      if requestor != "product"
         Products():Get(orln->PRODID, orderline:product, "orderline", refdat)
      endif
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return orderline

class Orderline
   data id
   data valueQuantity
   data valuePrice
   data order
   data product
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class Orderline
   self:id := 0
   self:valueQuantity := 0
   self:valuePrice := 0.00
   self:order := Order():New()
   self:product := Product():New()
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use orln index orln, orlna, orlnb
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = orderlines():Get(id, orderline():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               orln->DELETED := self:deleted
               orln->USERID := userid
               orln->TXDATE := txdate
               orln->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("ORLN")
         self:id = newId
         AddRec(1)	
         orln->ID := self:id
         /* BEGIN */
      orln->ORDRID := self:order:id
      orln->PRODID := self:product:id
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class Orderline
local retval := .T.
   set exact on
   if self:valueQuantity != old_rec:valueQuantity
      retval := .F.
   endif
   if self:valuePrice != old_rec:valuePrice
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class Orderline
   self:id := orln->ID 	
   self:valueQuantity := orln->QUANTITY
   self:valuePrice := orln->PRICE
   self:deleted := orln->DELETED 	
   self:userid := orln->USERID 	
   self:txdate := orln->TXDATE 	
   self:txtime := orln->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class Orderline
   orln->QUANTITY := self:valueQuantity
   orln->PRICE := self:valuePrice
   orln->DELETED := self:deleted
   orln->USERID := userid
   orln->TXDATE := txdate
   orln->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class Orderline
   if self:valueQuantity != old_rec:valueQuantity
      DbfLogAdd(alias(), "QUANTITY", old_rec:id, str(old_rec:valueQuantity), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:valuePrice != old_rec:valuePrice
      DbfLogAdd(alias(), "PRICE", old_rec:id, str(old_rec:valuePrice), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
Method IsProductInUse(nProdId) class Orderlines
   local old := select(), retval := .F.
   select 0
   use ordr index ordr
   select 0
   use orln index orln 		
   set relation to str(ORDRID)into ordr
   do while .not. eof()
      if orln->PRODID = nProdId
         if rtrim(ordr->STATUS) == "Placed"
            retval := .T.
            exit
         endif   
      endif 
      skip
   enddo
   use
   select("ORDR")
   use
   select(old)
return(retval)
/* END */
