/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class Products
   Method Init() constructor
   Method Find(prodid, products, refdat)
   Method Get(id, product, requestor, refdat)
   /* BEGIN */
   Method QueryOnAll()
   Method QueryOnDepartment(cDepartment)
   Method QueryOnProductcode(cProductcode)
   /* END */
endclass   

Method Init() class Products
return self

Method Find(prodid, products, refdat) class Products
   local old := select(), obj := {}
   select 0
   use prod index proda 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(prodid, 10)
      do while .not. eof() .and. prod->PRODID = prodid
         aadd(products, Product():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(prodid, 10)
      do while .not. eof() .and. prod->PRODID = prodid
         obj := SaveRec(obj)
         DbfLogRollback("PROD", prod->ID, refdat)
         if prod->DELETED == "N" .and. prod->INGDAT <= refdat 
            aadd(products, Product():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return products
   
Method Get(id, product, requestor, refdat) class Products
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use PROD index PROD
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("PROD", prod->ID, refdat)
         product:Transfer()	
         RestRec(obj)
      else
         product:Transfer()	
      endif
   endif
   if requestor != "old" 
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return product

class Product
   data id
   data codeProductExternal
   data nameProduct
   data codeDepartment
   data codeCategory
   data codeBrand
   data valuePrice
   data codePackagingunit
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class Product
   self:id := 0
   self:codeProductExternal := ""
   self:nameProduct := ""
   self:codeDepartment := ""
   self:codeCategory := ""
   self:codeBrand := ""
   self:valuePrice := 0.00
   self:codePackagingunit := ""
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use prod index prod, proda
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = products():Get(id, product():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               prod->DELETED := self:deleted
               prod->USERID := userid
               prod->TXDATE := txdate
               prod->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("PROD")
         self:id = newId
         AddRec(1)	
         prod->ID := self:id
         /* BEGIN */
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class Product
local retval := .T.
   set exact on
   if self:codeProductExternal != old_rec:codeProductExternal
      retval := .F.
   endif
   if self:nameProduct != old_rec:nameProduct
      retval := .F.
   endif
   if self:codeDepartment != old_rec:codeDepartment
      retval := .F.
   endif
   if self:codeCategory != old_rec:codeCategory
      retval := .F.
   endif
   if self:codeBrand != old_rec:codeBrand
      retval := .F.
   endif
   if self:valuePrice != old_rec:valuePrice
      retval := .F.
   endif
   if self:codePackagingunit != old_rec:codePackagingunit
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class Product
   self:id := prod->ID 	
   self:codeProductExternal := rtrim(prod->PRODCODE)
   self:nameProduct := rtrim(prod->PRODNAME)
   self:codeDepartment := rtrim(prod->DEPARTMENT)
   self:codeCategory := rtrim(prod->CATEGORY)
   self:codeBrand := rtrim(prod->BRAND)
   self:valuePrice := prod->PRICE
   self:codePackagingunit := rtrim(prod->PACKUNIT)
   self:deleted := prod->DELETED 	
   self:userid := prod->USERID 	
   self:txdate := prod->TXDATE 	
   self:txtime := prod->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class Product
   prod->PRODCODE := self:codeProductExternal
   prod->PRODNAME := self:nameProduct
   prod->DEPARTMENT := self:codeDepartment
   prod->CATEGORY := self:codeCategory
   prod->BRAND := self:codeBrand
   prod->PRICE := self:valuePrice
   prod->PACKUNIT := self:codePackagingunit
   prod->DELETED := self:deleted
   prod->USERID := userid
   prod->TXDATE := txdate
   prod->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class Product
   if self:codeProductExternal != old_rec:codeProductExternal
      DbfLogAdd(alias(), "PRODCODE", old_rec:id, old_rec:codeProductExternal, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameProduct != old_rec:nameProduct
      DbfLogAdd(alias(), "PRODNAME", old_rec:id, old_rec:nameProduct, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeDepartment != old_rec:codeDepartment
      DbfLogAdd(alias(), "DEPARTMENT", old_rec:id, old_rec:codeDepartment, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeCategory != old_rec:codeCategory
      DbfLogAdd(alias(), "CATEGORY", old_rec:id, old_rec:codeCategory, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeBrand != old_rec:codeBrand
      DbfLogAdd(alias(), "BRAND", old_rec:id, old_rec:codeBrand, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:valuePrice != old_rec:valuePrice
      DbfLogAdd(alias(), "PRICE", old_rec:id, str(old_rec:valuePrice), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codePackagingunit != old_rec:codePackagingunit
      DbfLogAdd(alias(), "PACKUNIT", old_rec:id, old_rec:codePackagingunit, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
Method QueryOnAll() class Products
   local old := select(), products := {}
   select 0
   use prod
   do while .not. eof()
      aadd(products, Product():New():Transfer()) 
      skip
   enddo
   use
   select(old)
return products

Method QueryOnDepartment(cDepartment) class Products
   local old := select(), products := {}
   select 0
   use prod  
   do while .not. eof()
      if rtrim(prod->DEPARTMENT) = cDepartment
         aadd(products, Product():New():Transfer()) 
      endif   
      skip
   enddo
   use
   select(old)
return products

Method QueryOnProductcode(cProductcode) class Products
   local old := select(), product := Product():New()
   select 0
   use prod index proda
   seek padr(cProductcode, 8)  
   if found()
      product:Transfer() 
   endif
   use
   select(old)
return product
/* END */
