/*
 HMGGEN - Harbour Application Generator source code

 Copyright 2014 Frank Alleman <f.alleman@chello.nl>

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of HMG.

 The exception is that, if you link the HMG library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 HMG library code into it.

 Parts of this project are based upon:

	HMG - Harbour Windows GUI library source code
	Copyright 2002-2010 Roberto Lopez <mail.box.hmg@gmail.com>
	http://sites.google.com/site/hmgweb/

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net> 

	"HWGUI"
  	Copyright 2001-2008 Alexander S.Kresin <alex@belacy.belgorod.su>

*/

#include <hmg.ch>

#define XID              aCode[n][1]
#define XTABEL           aCode[n][2]
#define XREF             aCode[n][3]
#define XCODE            aCode[n][4]
#define XCB              aCode[n][5]
#define XOMS             aCode[n][6]
#define XREFTABEL        aCode[n][7]
#define XDEFAULT         aCode[n][8]

#define XWinDbArray      dbflst
#define XDbName          dbflst[db_nr ][ 1] // filename
#define XDbModeFlag      dbflst[db_nr ][ 2] // .F. shared/.T. exclusive
#define XDbUse           dbflst[db_nr ][ 3] // R = read/W = read/write
#define XDbIndex         dbflst[db_nr ][ 4] // aantal indexfiles
#define XDbOrder         dbflst[db_nr ][ 5] // indexvolgorde OBSOLETE
#define XDbArea          dbflst[db_nr ][ 6] // workarea
#define XDbPtr           dbflst[db_nr ][ 7] // current recno OBSOLETE
#define XDbOpenFlag      dbflst[db_nr ][ 8] // .T. geopend in current window
#define XDbSignature     dbflst[db_nr ][ 9] // signatuurveld OBSOLETE
#define XDbDelete        dbflst[db_nr ][10] // .T. fysiek verwijderen
#define XDbLog           dbflst[db_nr ][11] // .T. write to logfile OBSOLETE
#define Seconds          1


/* common utilities */

/* load combobox from table refc */ 
function LoadRefdata(nApplid)
	local old := select(), aCode , pos
   aCodes := {}
   select 0
	use refc index refca
   seek str(nApplid, 10)
	do while .not. eof() .and. refc->APPLID = nApplid
      aCode := {ID, TABEL, rtrim(REF), rtrim(CODE), CB, if(language = 1, rtrim(OMS), rtrim(OMSUK)), rtrim(REFTABEL), DEFAULT}
      pos := ascan(aCodes, {|x|x[1] == rtrim(refc->TABEL)})
      if pos = 0
         aadd(aCodes, {rtrim(refc->TABEL), {}})
         aadd(aCodes[len(aCodes), 2], aCode)
      else
         aadd(aCodes[pos, 2], aCode)
      endif   
      skip
   enddo
	use
   select(old)
return(nil)

/* load combobox from table refc */ 
function LoadRefdataEx(applid)
	local old := select(), aCode, pos 
   select 0
	use refc index refca
   seek str(nApplid, 10)
	do while .not. eof() .and. refc->APPLID = nApplid
      if  rtrim(refc->TABEL) == "BEHANDTEAM"
         aCode := {ID, TABEL, rtrim(REF), rtrim(CODE), CB, if(language = 1, rtrim(OMS), rtrim(OMSUK)), rtrim(REFTABEL), DEFAULT}
         pos := ascan(aCodes, {|x|x[1] == rtrim(refc->TABEL)})
         if pos = 0
            aadd(aCodes, {rtrim(refc->TABEL), {}})
            aadd(aCodes[len(aCodes), 2], aCode)
         else
            aadd(aCodes[pos, 2], aCode)
         endif
      endif   
      if  rtrim(refc->TABEL) == "ROL"
         aCode := {ID, TABEL, rtrim(REF), rtrim(CODE), CB, if(language = 1, rtrim(OMS), rtrim(OMSUK)), rtrim(REFTABEL), DEFAULT}
         pos := ascan(aCodes, {|x|x[1] == rtrim(refc->TABEL)})
         if pos = 0
            aadd(aCodes, {rtrim(refc->TABEL), {}})
            aadd(aCodes[len(aCodes), 2], aCode)
         else
            aadd(aCodes[pos, 2], aCode)
         endif
      endif   
      skip
   enddo
	use
   select(old)
return(nil)

// populate codes from array
function ComboLoadItems(tablename, combo, parent)
local n, value, acode
   aCode := aCodes[ascan(aCodes, {|x|x[1] == tablename}), 2]
	// first clear combo
  	 _DeleteAllItems(combo, parent)
	for n := 1 to len(aCode)
      if aCode[n, 5] != "Y" .or. userprofile:valueAuthorization >= 30
         value := aCode[n, 6]
         _AddItem(combo, parent, value)
      endif   
	next
return(nil)

// populate codes from array with filter on cRefCode  
function ComboLoadItemsEx(tablename, combo, parent, cRefCode)
local n, value, aCode
   aCode := aCodes[ascan(aCodes, {|x|x[1] == tablename}), 2]
	// first clear combo
  	 _DeleteAllItems(combo, parent)
	for n := 1 to len(aCode)
      if aCode[n, 5] != "Y" .or. userprofile:valueAuthorization >= 30
         if aCode[n, 3] == cRefCode
            value := aCode[n, 6]
            _AddItem(combo, parent, value)
         endif
      endif
	next
return(nil)

function GridComboLoadItems(tablename, items)
local n, value, aCode
   aCode := aCodes[ascan(aCodes, {|x|x[1] == tablename}), 2]
	for n := 1 to len(aCode)
      if aCode[n, 5] != "Y" .or. userprofile:valueAuthorization >= 30
         value := aCode[n, 4]
         aadd(items, value)
      endif   
	next
return(items)

// lookup index of given code
function ComboLookupValue(tablename, combo, parent, cCode)
local n, retval := 0, len, oms, aCode
   aCode := aCodes[ascan(aCodes, {|x|x[1] == tablename}), 2]
   cCode := rtrim(cCode)
	// lookup decription in aCode
	oms := ComboLookupDescr(tablename, cCode)
	// lookup description in combo
	len := _GetItemCount(combo, parent)
	for n:= 1 to len
		if _GetItem(combo, parent, n) == oms
			retval := n
			exit
		endif				
	next
return(retval)

// lookup index of default value
function ComboLookupDefault(tablename, combo, parent, cRefCode)
local n, n_old, aCode_old, retval := 0, aCode, filtervalue
   aCode := aCodes[ascan(aCodes, {|x|x[1] == tablename}), 2]
	for n := 1 to len(aCode)
      if XDEFAULT = "Y"
         if empty(XREFTABEL) 
            retval := ComboLookupValue(tablename, combo, parent, XCODE)            
            exit
         else
            if pcount() = 3
               n_old := n
               aCode_old := aCode
               aCode := aCodes[ascan(aCodes, {|x|x[1] == XREFTABEL}), 2]
               for n := 1 to len(aCode)
                  if XDEFAULT = "Y" 
                     filtervalue := XCODE            
                     exit
                  endif
               next
               n := n_old
               aCode := aCode_old
               if XREF == filtervalue
                  retval := ComboLookupValue(tablename, combo, parent, XCODE)            
                  exit
               endif   
            else
               if XREF == cRefCode
                  retval := ComboLookupValue(tablename, combo, parent, XCODE)            
                  exit
               endif   
            endif   
         endif   
		endif
	next
return(retval)

function GridComboLookupValue(tablename, cCode)
local n, retval := 0, aCode
   aCode := aCodes[ascan(aCodes, {|x|x[1] == tablename}), 2]
	for n:= 1 to len(aCode)
		if aCode[n, 4] == cCode
         retval := n
			exit
		endif				
	next
return(retval)

// setindex of given code
function ComboSetValue(tablename, combo, parent, cCode)
local n, len, oms, aCode
   aCode := aCodes[ascan(aCodes, {|x|x[1] == tablename}), 2]
	// lookup description in aCode
	oms := ComboLookupDescr(tablename, cCode)
	// set index of description
	len := _GetItemCount(combo, parent)
	for n:= 1 to len
		if _GetItem(combo, parent, n) == oms 
			_SetValue(combo, parent, n)
			exit
		endif				
	next
return(nil)

// lookup current code
function ComboGetCode(tablename, combo, parent)
local n, len, cCode := "", oms, aCode
   aCode := aCodes[ascan(aCodes, {|x|x[1] == tablename}), 2]
	oms := _GetItem(combo, parent, _GetValue(combo, parent)) 
	// lookup code in aCode
	for n:= 1 to len(aCode)
		if aCode[n, 6] == oms
			cCode := aCode[n, 4]
			exit
		endif
	next
return(cCode)

function GridComboGetCode(tablename, n)
local cCode := "", aCode
   aCode := aCodes[ascan(aCodes, {|x|x[1] == tablename}), 2]
   if n > 0
      cCode := aCode[n, 4]
   endif   
return(cCode)

// lookup description in table aCode on cCode
function ComboLookupDescr(tablename, cCode)
local n, oms := "", aCode
   aCode := aCodes[ascan(aCodes, {|x|x[1] == tablename}), 2]
	for n:= 1 to len(aCode)
		if aCode[n, 4] == cCode
			oms := aCode[n, 6]
			exit
		endif
	next
return(oms)

function ComboGetValueDirect(combo, parent, cCode)
local n, retval := 0, len, oms
   cCode := rtrim(cCode)
	len := _GetItemCount(combo, parent)
	for n:= 1 to len
		if _GetItem(combo, parent, n) == cCode
			retval := n
			exit
		endif				
	next
return(retval)

// removes {|| and } from variable
function Unblock(block)
local n, counter := 0, posl := 1, posr := len(rtrim(block)), retval := ""
if posr > 0
   for n := 1 to posr
        if substr(block, n, 1) = '|'
           if counter = 1
              posl := n + 1
              exit
           else
              counter++
           endif
        endif
    next
    if n > posr
      retval := rtrim(block)
    else
      retval := substr(block, posl, posr - posl)
    endif  
endif
return(retval)

// concatenates words within param cS1, each concatenated word starts with a capital
function Concatenate(cS1)
   local cS2 := "", cC, n, bNewWord := .F.
   for n := 1 to len(rtrim(cS1))
      cC := substr(cS1, n, 1)
      if empty(cC)
         bNewWord := .T.
      else
         if bNewWord
            cS2 += Upper(cC)
            bNewWord := .F.
         else
            cS2 += cC
         endif
      endif      
   next
   cS1 := cS2
return(cS1)

// converts first character of param s to capital
function FirstToUpper(s)
return(upper(substr(s, 1, 1)) + substr(s, 2))

// converts first character of param s to lower case
function FirstToLower(s)
return(lower(substr(s, 1, 1)) + substr(s, 2))

// authorizes user
function AuthEval(number)
local retval := .F., n
if userprofile:valueAuthorization = number
   retval := .T.
else
   if number % 10 = 0
      if int(userprofile:valueAuthorization / 10) >= int(number / 10)
         retval := .T.
      endif
   else
      if int(userprofile:valueAuthorization / 10) >  int(number / 10)
         retval := .T.
      endif
   endif
endif
return(retval)

// converts object to a xml string
function obj2xml(ob, s)
local m, n, aData
	s += "<" + substr(ob:classname,1,1) + lower(substr(ob:classname,2)) + ">"
   aData := __objGetValueList(ob)
	for n := 1 to len(aData)
		do case
		case valtype(aData[n, 2]) = "C"
		     s += "<" + lower(aData[n, 1]) + ">"
		     s += aData[n, 2]
		     s += "</" + lower(aData[n, 1]) + ">"
		case valtype(aData[n, 2]) = "N"
		     s += "<" + lower(aData[n, 1]) + ">"
		     s += ltrim(str(aData[n, 2]))
		     s += "</" + lower(aData[n, 1]) + ">"
		case valtype(aData[n, 2]) = "L"
		     s += "<" + lower(aData[n, 1]) + ">"
		     s += if(aData[n, 2], ".T.", ".F.") 	
		     s += "</" + lower(aData[n, 1]) + ">"
		case valtype(aData[n, 2]) = "D"
		     s += "<" + lower(aData[n, 1]) + ">"
		     s += dtoc(aData[n, 2]) 	
		     s += "</" + lower(aData[n, 1]) + ">"
		case valtype(aData[n, 2]) = "O"
   		     obj2xml(aData[n, 2], @s)
		case valtype(aData[n, 2]) = "A"
		     s += "<" + lower(aData[n, 1]) + ">"
		     for m := 1 to len(aData[n, 2])
				obj2xml(aData[n, 2, m], @s)
		     next	 
		     s += "</" + lower(aData[n, 1]) + ">"
		otherwise // "U"
		endcase
	next
	s += "</" + substr(ob:classname,1,1) + lower(substr(ob:classname,2)) + ">"
return(s)
 
// converts xml string to an object
function xml2obj(xml)
local rec := "", cur, eof, aData, parent, parenttype
cur := 1
eof := len(xml) + 1
aData := {}
parent := 0
parenttype := "root"
rec := ReadTag(xml, @cur, eof, @rec)
return(ProcessTag(xml, @cur, eof, rec, aData, parent, parenttype))

// processes xml tag
function ProcessTag(handle, cur, eof, rec, aData, parent, parenttype)
local n, obj, tagname := "", tagvalue, bCap := .F.
private s
if len(rec) >= 1
	if substr(rec, 1, 1)$"ABCDEFGHIJKLMNOPQRSTUVWXYZ"
		// tag starts with capital, tag contains classname
		bCap := .T.
		if parenttype != "class"
         // type is root of collection
			tagname := rec
			s := tagname + "():New()"
			obj := &s.
         if parenttype == "collection"	
            aadd(parent, obj)
         endif
      else
			tagname := rec
		 n := ascan(aData, {|x|x[1] = upper(tagname)})
         if n > 0
            obj := aData[n, 2]
         else
            MsgInfo("xml fault")
         endif   
      endif
      parent := obj
		// create aData struct
		aData := __objGetValueList(obj)
	else
		// tag start with lower case character, tag contains attributename
		tagname := rec
		tagvalue := ReadValue(handle, @cur, eof, @rec)
		// populate aData
		n := ascan(aData, {|x|x[1] = upper(tagname)})
		if n > 0
			do case
				case valtype(aData[n, 2]) = "C"
				     aData[n, 2] = tagvalue
				case valtype(aData[n, 2]) = "N"
				     aData[n, 2] = val(tagvalue)
				case valtype(aData[n, 2]) = "L"
				     aData[n, 2] = if(tagvalue = ".T.", .T., .F.)
				case valtype(aData[n, 2]) = "D"
				     aData[n, 2] = ctod(tagvalue)
				case valtype(aData[n, 2]) = "A"
				     parent := aData[n, 2]
			endcase
		endif
	endif
endif
ReadTag(handle, @cur, eof, @rec)
do while cur < eof .and. len(rec) >= 1 .and. !(substr(rec,1,1) == "/" .and. substr(rec,2) == tagname)
   ProcessTag(handle, @cur, eof, rec, aData, parent, if(bCap, "class", "collection"))
	ReadTag(handle, @cur, eof, @rec)
enddo
if bCap
	// update object
	__objSetValueList(obj, aData)
endif
return(obj)

// read a xml tag from a file
function ReadTag(xml, cur, eof, rec)
   rec := ""	
   do while cur < eof .and. substr(xml, cur, 1) <> ">"
      if substr(xml, cur, 1) = "<"
      elseif substr(xml, cur, 1) = chr(13) // CR
     	elseif substr(xml, cur, 1) = chr(10) // LF
     	elseif substr(xml, cur, 1) = chr(9) // Tab
     	else
		rec += substr(xml, cur, 1)
	endif
      cur++
   enddo
   if cur < eof
      cur++
   endif 		
return(rec)

function ReadValue(xml, cur, eof, rec)
   rec := ""	
   do while cur < eof .and. substr(xml, cur, 1) <> "<"
	rec += substr(xml, cur, 1)
      cur++
   enddo
return(rec)

// Decrypt to_do
function Decrypt(to_do)
padback = len(to_do)
done = ""
to_do = ltrim(trim(to_do))
for qaz = len(to_do) to 1 step -1
    done = done + chr(asc(substr(to_do, qaz,1)) - 104)
next
return(padr(done, padback))

// Checks whether cValue contains a numeric value or not
function IsNumeric(cValue)
	local bNumeric := .T., n
	if empty(cValue)
      bNumeric := .F.
   else   
      for n := 1 to len(cValue)
         if substr(cValue, n, 1)$"0123456789."
         else
            bNumeric := .F.
            exit
         endif		
      next
   endif   
return(bNumeric)

// Returns formatted numeric value of cValue
function GetNumericMask(cValue)
	local nPos, nDec, cMask := "9999999999" 
	nPos := at(".", cValue)
	if nPos = 0
	else
		nDec := len(cValue) - nPos
		cMask := stuff(cValue, (10 - nDec), 1, ".")
	endif
return(cMask)

// Retrievs faultmessage from database table
function GetMessage(cFaultCode)
   local cFaultMessage := ""
   select 0
   use mssg index mssg
   seek padr(cFaultcode, 6)
   if found()
      if language = 1
         cFaultMessage := mssg->FLTTEXT
      else
         cFaultMessage := mssg->FLTTEXTUL
      endif
   endif
   use
return(cFaultMessage)


/* database utilities */

// Adds logrecord to table clog
function DbfLogAdd(classname, fieldname, refid, val, txdate, txtime, enddate, endtime, userid)
local old := select(), newid, enddate_old := ctod("31-12-2099"), value_old := ""
select 0
use clog index clog, cloga
// index on CLASSNAME+str(REFID)+descend(dtos(TXDATE)+TXTIME)+USERID to cloga
set order to 2 
seek padr(classname, 10)+str(refid, 10)
do while .not. eof() .and. rtrim(clog->CLASSNAME) == classname .and. clog->REFID = refid
   // delete more recent updates on attribute from log
   if clog->ENDDATE > enddate .and. rtrim(clog->FIELDNAME) == fieldname
      if clog->ENDDATE < enddate_old
         value_old := clog->VALUE
         enddate_old := clog->ENDDATE 
      endif  
      RecLock(1)
      delete
      unlock
   endif
   skip
enddo
set order to 1
newid := DbfGetId("CLOG")
AddRec(1)		
replace ID		   with newid
replace REFID		with refid
replace TXDATE		with txdate
replace TXTIME    with txtime
replace ENDDATE	with enddate
replace ENDTIME   with "00:00:00"
replace CLASSNAME	with classname
replace FIELDNAME with fieldname
if empty(value_old)
   do case
      case 	valtype(val) = "C"
         replace VALUE		with val
      case 	valtype(val) = "N"
         replace VALUE		with ltrim(str(val))
      case 	valtype(val) = "D"
         replace VALUE		with dtoc(val)
      case 	valtype(val) = "L"
         replace VALUE		with if(val, "J", "N")
   endcase
else
   do case
      case 	valtype(value_old) = "C"
         replace VALUE		with value_old
      case 	valtype(value_old) = "N"
         replace VALUE		with ltrim(str(value_old))
      case 	valtype(value_old) = "D"
         replace VALUE		with dtoc(value_old)
      case 	valtype(value_old) = "L"
         replace VALUE		with if(value_old, "J", "N")
   endcase
endif   
replace USERID		with userid
unlock
use 
select(old)
return(nil)

// Reconstructs state of object with given refid at refdat
function DbfLogRollback(classname, refid, refdat)
local old := select(), ob := {}, ob2, oblist := {}, struct, n, txdate_oud, txtime_oud, userid_oud, pos
select(classname)
struct := dbstruct()
for n:= 1 to len(struct)
   // ob is populated from CURRENT record
	aadd(ob, fieldget(n))
next
select 0
use clog index cloga
seek padr(classname, 10)+str(refid, 10)
do while .not. eof() .and. rtrim(clog->CLASSNAME) == classname .and. clog->REFID = refid
   if pcount() < 3 .or. clog->ENDDATE > refdat
      txdate_oud  :=  clog->TXDATE
      txtime_oud  :=  clog->TXTIME
      do while .not. eof() .and. rtrim(clog->CLASSNAME) == classname .and. clog->REFID = refid ;
      .and. clog->TXDATE = txdate_oud .and. clog->TXTIME = txtime_oud
         userid_oud  :=  clog->USERID
         if pcount() < 3
            pos := ascan(struct, {|x|x[1] = "TXDATE"})
            ob[pos]     :=  clog->TXDATE
            pos := ascan(struct, {|x|x[1] = "TXTIME"})
            ob[pos]     :=  clog->TXTIME
            pos := ascan(struct, {|x|x[1] = "USERID"})
            ob[pos]     :=  clog->USERID
         else
            select(classname)
            RecLock(1)
            pos := ascan(struct, {|x|x[1] = "TXDATE"})
            fieldput(pos, clog->TXDATE)
            pos := ascan(struct, {|x|x[1] = "TXTIME"})
            fieldput(pos, clog->TXTIME)
            pos := ascan(struct, {|x|x[1] = "USERID"})
            fieldput(pos, clog->USERID)
            unlock
            select("clog")
         endif      
         do while .not. eof() .and. rtrim(clog->CLASSNAME) == classname .and. clog->REFID = refid ;
         .and. clog->TXDATE = txdate_oud .and. clog->TXTIME = txtime_oud .and. clog->USERID = userid_oud
            // update object ob from mutlog
            pos := ascan(struct, {|x|x[1] = rtrim(clog->FIELDNAME)})
            if pos > 0
               if pcount() < 3
                  do case
                     case struct[pos, 2] = "C"
                        ob[pos] := rtrim(clog->VALUE)
                     case struct[pos, 2] = "N"
                        ob[pos] := val(rtrim(clog->VALUE))
                     case struct[pos, 2] = "D"
                        ob[pos] := ctod(rtrim(clog->VALUE))
                     case struct[pos, 2] = "L"
                        if(rtrim(clog->VALUE) == "J",  ob[pos] := .T., ob[pos] := .F.)
                  endcase
               else
                  select(classname)
                  RecLock(1)
                  do case
                     case struct[pos, 2] = "C"
                        fieldput(pos, rtrim(clog->VALUE))
                     case struct[pos, 2] = "N"
                        fieldput(pos, val(rtrim(clog->VALUE)))
                     case struct[pos, 2] = "D"
                        fieldput(pos, ctod(rtrim(clog->VALUE)))
                     case struct[pos, 2] = "L"
                        if(rtrim(clog->VALUE) == "J",  fieldput(pos, .T.), fieldput(pos, .F.))
                  endcase
                  unlock
                  select("clog")
               endif
            endif	
            skip
         enddo
         if pcount() < 3
            ob2 := aclone(ob)
            aadd(oblist, ob2)
         endif      
      enddo
   else
      skip
   endif  
enddo
use
select(old)
return(oblist)

function DbfLogIsLatest(classname, fieldname, refid, refdat)
local old := select(), retval := .T. 
select 0
use clog index cloga
seek padr(classname, 10)+str(refid, 10)
do while .not. eof() .and. rtrim(clog->CLASSNAME) == classname .and. clog->REFID = refid
   if clog->ENDDATE > refdat .and. rtrim(clog->FIELDNAME) == fieldname
      retval := .F.
      exit
   endif
   skip
enddo
use
select(old)
return(retval)

// Returns first available id for new record 
function DbfGetId(workarea)
	local old, recno, inxord, retval := 1
	if pcount() > 0
		old := select()
		select(workarea)
	endif
	recno := recno()
	inxord := indexord()
   set order to 1
   set deleted off
	go bottom
	if .not. eof()
		retval := ID + 1
	endif
   set deleted on
	set order to inxord
	go recno
	if pcount() > 0
		select(old)
	endif
return(retval)

FUNCTION AddRec( nWaitSeconds )
   LOCAL lForever
   APPEND BLANK
   IF .NOT. NETERR()
      RETURN (.T.)
   ENDIF
   lForever = (nWaitSeconds = 0)
   DO WHILE (lForever .OR. nWaitSeconds > 0)
      APPEND BLANK
      IF .NOT. NETERR()
         RETURN .T.
      ENDIF
      INKEY(.5)         // Wait 1/2 second
      nWaitSeconds  = nWaitSeconds  - .5
   ENDDO
RETURN (.F.)         // Not locked

FUNCTION RecLock( nSeconds )
   LOCAL lForever
   IF RLOCK()
      RETURN (.T.)        // Locked
   ENDIF
   lForever = (nSeconds = 0)
   DO WHILE (lForever .OR. nSeconds > 0)
      IF RLOCK()
         RETURN (.T.)     // Locked
      ENDIF
      INKEY(.5)           // Wait 1/2 second
      nSeconds = nSeconds - .5
   ENDDO
RETURN (.F.)           // Not locked

// Opens files in dbflst
function DbfLstOpen(dbflst)
local db_nr, no_error := .T.
db_nr    := 1
do while db_nr <= len(XWinDbArray) .and. no_error
   if file(XDbName + ".DBF")
      if (XDbName)->(used()) // if used within same application
         select(XDbName)
         set order to XDbOrder
         XDbOpenFlag := .F.
         XDbArea     := select()
      else
         select 0
         if NetUse(XDbName, XDbModeFlag, Seconds)
            if XDbIndex = 1
               set index to (XDbName)
            elseif XDbIndex = 2
               set index to (XDbName), (XDbName + "A")
            elseif XDbIndex = 3
               set index to (XDbName), (XDbName + "A"), (XDbName + "B")
            elseif XDbIndex = 4
               set index to (XDbName), (XDbName + "A"), (XDbName + "B"), ;
                            (XDbName + "C")
            elseif XDbIndex = 5
               set index to (XDbName), (XDbName + "A"), (XDbName + "B"), ;
                            (XDbName + "C"), (XDbName + "D")
            endif
            set order to XDbOrder
            XDbOpenFlag := .T.
            XDbArea     := select()
            /* obsolete */
            XDbPtr      := recno()
         else // used by other user
            no_error := .F.
         endif
      endif
   else
      no_error := .F.
   endif
   db_nr++
enddo
return(no_error)

// Closes files in dbflst
function DbfLstClose(dbflst)
local db_nr
db_nr := 1
do while db_nr <= len(XWinDbArray)
   if XDbOpenFlag = .T.
      select(XDbArea)
      use
      if XDbDelete
         ferase(XDbName + ".DBF")
         if XDbIndex = 1
            ferase(XDbName + ".NTX")
         elseif XDbIndex = 2
            ferase(XDbName + "A.NTX")
         elseif XDbIndex = 3
            ferase(XDbName + "B.NTX")
         elseif XDbIndex = 4
            ferase(XDbName + "C.NTX")
         elseif XDbIndex = 5
            ferase(XDbName + "D.NTX")
         endif
      endif
   endif
   db_nr++
enddo
return(NIL)

//
//  NetUse( <cDatabase>, <lOpenMode>, <nWaitSeconds> ) --> lSuccess
//  Attempt to USE a database file with optional retry
//
FUNCTION NetUse( cDatabase, lOpenMode, nSeconds )
   LOCAL lForever
   lForever = (nSeconds = 0)
   DO WHILE (lForever .OR. nSeconds > 0)
     IF lOpenMode
         USE (cDatabase) EXCLUSIVE
     ELSE
         USE (cDatabase) SHARED // Shared
     ENDIF
     IF .NOT. NETERR()          // USE succeeds
        RETURN (.T.)
      ENDIF
      INKEY(1)                 // Wait 1 second
      nSeconds = nSeconds - 1
   ENDDO
RETURN (.F.)                // USE fails

// Save values of database fields in array 
function SaveRec(ob)
local struct, n
   struct := dbstruct()
   ob := {}
   for n:= 1 to len(struct)
      aadd(ob, fieldget(n))
   next
return(ob)   

// Restores values of database fields from array 
function RestRec(ob)
local struct, n
   struct := dbstruct()
   RecLock(1)
   for n:= 1 to len(ob)
      if ob[n] != fieldget(n) 
         fieldput(n, ob[n])
      endif   
   next
   unlock
return(nil)

function GetPseudoId()
   local nPseudoId_old := nPseudoId
   aadd(aPseudoId, {nPseudoId_old, 0})
   nPseudoId--
return(nPseudoId_old)

