#include "hmg.ch"

#define _LOGFILE

declare window ORO110
declare window ORO120
declare window ORP110
declare window ORP120
declare window HGW010

Function main()
   public aCodes := array(4), userprofile, nIdentity, nApplid := 3, language := 2, ;
   customer := nil, order, orderline, product
   set scoreboard off
   set deleted on
   set date format to "dd-mm-yyyy"
   set epoch to 1920
   set wrap on
   set exclusive off
   set confirm on
   setcancel(.F.)
   // for index cloga
   external descend
   altd(1)
   load window OR0000
   OR0000.Width := GetDesktopWidth()
   OR0000.Height := GetDesktopHeight()
   OR0000.Grid_1_1.Width := GetDesktopWidth()
   OR0000.Grid_1_1.Height := 200
   OR0000.Grid_1_2.Width := GetDesktopWidth()
   OR0000.Grid_1_2.Height := GetDesktopHeight() - 68 - 64 - 200 
 	OR0000.Maximize()
	OR0000.Activate()
Return

function OR0000_OnInit()
   local n, logfile
   for n:= 1 to 4
      aCodes[n] := {}
   next
   LoadRefdata(nApplid)
   #ifdef _LOGFILE
      logfile := fcreate("rules.log")
      fclose(logfile)
   #endif
   load window HG0010
	HG0010.Activate()
   UpdateAllViews()
return(nil)

function UpdateAllViews()
   UpdateCustomerView()
return(nil)

function OnInBox()
   if Iswindowdefined(HGW010)
      HGW010.Release()
   endif
   load window HGW010
   HGW010.Activate()
return(nil)

function OnSelectCustomer()
   if Iswindowdefined(ORO110)
      ORO110.Release()
   endif
   OR0000.USECASE.Value := "Select customer"
   load window ORO110
   ORO110.Activate()
return(nil)

function OnPlaceOrder()
   OR0000.USECASE.Value := "Place order"
   if AuthEval(21) 
      if empty(customer)
         if Iswindowdefined(ORO110)
            ORO110.Release()
         endif
         load window ORO110
         ORO110.Activate()
      else
         order := Order():New()
         aadd(customer:orders, order)
         if Iswindowdefined(ORO120)
            ORO120.Release()
         endif
         load window ORO120
         ORO120.Activate()
      endif
   else
      MsgInfo("Not accessible")
   endif   
return(nil)

function OnAdjustOrder()
   local aItem
   if AuthEval(21) 
      if empty(customer)
         MsgInfo("Please select a customer and an order first")
         return(nil)
      endif
      if OR0000.grid_1_2.value = 0
         MsgInfo("Please select an order first")
         return(nil)
      endif 
      aItem := OR0000.grid_1_2.Item(OR0000.grid_1_2.value)
      order := customer:orders[ascan(customer:orders, {|x|x:id = aItem[5]})]
      /* refresh order from database */
      Orders():Get(aItem[5], order, "orderline") 
      if order:descrStatus == "Placed"   
         OR0000.USECASE.Value := "Adjust order"
         if Iswindowdefined(ORO120)
            ORO120.Release()
         endif
         load window ORO120
         ORO120.Activate()
      else
         MsgInfo("Order can't be adjusted anymore")
      endif   
    else
      MsgInfo("Not accessible")
    endif  
return(nil)

function OnDeliverOrder()
   local nCaseId, nObjectId, order
   /*
   In a realistic scenario you might add the order to a picklist within the delivery system,
   including the caseid as external reference.
   When the order has been delivered, the deliverysystem might invoke the function
   WfmUpdateStatus directly from outside.
   */
   MsgInfo("Picked up and transported to local picklist")
   nCaseId := WfmGetCurrentCaseId() 
   nObjectId := WfmGetObjectId(nCaseId)
   order := Orders():Get(nObjectId, Order():New(), "order")
   order:descrStatus := "Delivered"
   order:Save(date(), time(), userprofile:userid, date())
   WfmUpdateStatus("Process order", "Deliver order", nCaseId, "Order delivered", "", "Continue")
return(nil)

function OnUpdateAssortment()
   if AuthEval(22) 
      OR0000.USECASE.Value := "Update assortment"
      if Iswindowdefined(ORP110)
         ORP110.Release()
      endif
      load window ORP110
      ORP110.Activate()
    else
      MsgInfo("Not accessible")
    endif  
return(nil)

function OnApproveNewProduct()
   OR0000.USECASE.Value := "Approve new product"
   if Iswindowdefined(ORP120)
      ORP120.Release()
   endif
   load window ORP120
   ORP120.Activate()
return(nil)

function OnAdjustNewProduct()
   OR0000.USECASE.Value := "Adjust new product"
   if Iswindowdefined(ORP120)
      ORP120.Release()
   endif
   load window ORP120
   ORP120.Activate()
return(nil)

function OnApplyNewProduct(nCaseId, nObjectId)
   local oProduct, retval := .T.
   oProduct := Product():New()
   oproduct := xml2obj(WfmLookupDossier(nCaseId))
   if date() >= oProduct:txdate
      oProduct:Save(date(), time(), userprofile:userid, date())
      /* because this function is called within HGW010_StartNextActivity(), don't add param "Continue" */
      WfmUpdateStatus("Update assortment", "Apply new product", nCaseId, "New product applied", "")
   else
      retval := .F.
   endif
return(retval)

function OnChangePrice()
   if AuthEval(22) 
      OR0000.USECASE.Value := "Change price"
      if Iswindowdefined(ORP110)
         ORP110.Release()
      endif
      load window ORP110
      ORP110.Activate()
   else
      MsgInfo("Not accessible")
   endif  
return(nil)

function OnApprovePricechange()
   OR0000.USECASE.Value := "Approve pricechange"
   if Iswindowdefined(ORP120)
      ORP120.Release()
   endif
   load window ORP120
   ORP120.Activate()
return(nil)

function OnAdjustPricechange()
   OR0000.USECASE.Value := "Adjust pricechange"
   if Iswindowdefined(ORP120)
      ORP120.Release()
   endif
   load window ORP120
   ORP120.Activate()
return(nil)

function OnApplyPricechange(nCaseId, nObjectId)
   local n, oPricechange, oProducttype, product, retval := .T.
   oPricechange := Pricechange():New()
   oPricechange := xml2obj(WfmLookupDossier(nCaseId))
   if date() >= oPricechange:startdate
      for n := 1 to len(oPricechange:producttypes)
         oProducttype := oPricechange:producttypes[n] 
         product := Products():QueryOnProductcode(oProducttype:productcode)
         if product:id > 0
            product:valuePrice := oProducttype:price
            product:Save(date(), time(), userprofile:userid, date())
         else
            MsgInfo("Product not found, please contact your servicedesk (error PROD1)")
            return(nil)
         endif
      next     
      /* because this function is called within HGW010_StartNextActivity(), don't add param "Continue" */
      WfmUpdateStatus("Change price", "Apply pricechange", nCaseId, "Pricechange applied", "")
   else
      retval := .F.
   endif
return(retval)

function OnCampaign()
   local customers, c, n, nCaseId
   if AuthEval(21) 
      customers := Customers():QueryAll()
      for n := 1 to len(customers)
         c := customers[n]
         nIdentity := c:id
         nCaseId := WfmMakeCase("Campaign", c:id, "", date(), time())
         WfmUpdateStatus("Campaign", "Send letter", nCaseId, "Letter sent", "", "continue")
      next
   else
      MsgInfo("Not accessible")
   endif     
return(nil)

function OnSendLetter()
   MsgInfo("Letter has been sent")
return(.T.)

function OnRegisterResponse()
   MsgInfo("Response has been registered")
   // MsgInfo("nIdentity " + str(nIdentity))
   // nCaseId := WfmLookupCase("Campaign", nIdentity)
   nCaseId := WfmGetCurrentCaseId()
   WfmUpdateStatus("Campaign", "Register response", nCaseId, "Response registered", "", "continue")
return(nil)

function HG0010_OnInteractiveClose()
return(.F.)

function HG0010_OnOk()
local value, user_id, pass_word, s
value := HG0010.PASSWORD.Value
user_id  := HG0010.USERNAME.Value
if empty(user_id)
   s := "Please enter your username" + chr(13) + chr(10)
   s += chr(13) + chr(10)
   s += "For this demo:" + chr(13) + chr(10)
   s += "SA1 = user with role Sales representative" + chr(13) + chr(10)   
   s += "SA2 = user with role Sr. Sales representative" + chr(13) + chr(10)   
   s += "SA3 = user with role Sr. Sales representative" + chr(13) + chr(10)   
   s += "DV1 = user with role Storekeeper" + chr(13) + chr(10)   
   s += "AP1 = user with role Application manager" + chr(13) + chr(10)   
   s += "Password not required" + chr(13) + chr(10)   
   MsgInfo(s)
   HG0010.USERNAME.Setfocus
   return(nil)
endif
userprofile := Users():QueryOnUserid(user_id, User():New())
if userprofile:id > 0
   pass_word := rtrim(userprofile:codePassword)
   if !empty(pass_word)
      pass_word := decrypt(pass_word)
   endif   
   if pass_word == value
      /* get userprofile */
      HG0010.Hide
      HG0010.Release
   else
      MsgInfo("Please enter your password again")
      HG0010.PASSWORD.Setfocus
   endif
else
   MsgInfo("Please enter your username again")
   HG0010.USERNAME.Setfocus
endif   
return(nil)

function HG0010_OnCancel()
   HG0010.USERNAME.Value := ""
   HG0010.PASSWORD.Value := ""
   HG0010.USERNAME.Setfocus
return(nil)

function OnDailyRun()
   if AuthEval(30) 
      load window HGW110
      HGW110.Activate()
   else
      MsgInfo("Not accessible")
   endif  
return(nil)
   
function DailyRun()
   local cdRundate, nCount
   dRundate := HGW110.RUNDATE.Value
   /* first time only count */
   nCount := WfmRecall("Campaign", "Wait for response", "Response not received", {|x,y,z|SendRecallLetter(x,y,z)}, 2, dRundate, .T.)
   nCount += WfmApplyChanges("Change price", "Apply pricechange", {|x,y,z|ApplyPricechange(x,y,z)}, dRundate, .T.)
   nCount += WfmApplyChanges("Update assortment", "Apply new product", {|x,y,z|ApplyNewProduct(x,y,z)}, dRundate, .T.)
   Barchart(nCount)
   WfmRecall("Campaign", "Wait for response", "Response not received", {|x,y,z|SendRecallLetter(x,y,z)}, 2, dRundate)
   WfmApplyChanges("Change price", "Apply pricechange", {|x,y,z|ApplyPricechange(x,y,z)}, dRundate)
   WfmApplyChanges("Update assortment", "Apply new product", {|x,y,z|ApplyNewProduct(x,y,z)}, dRundate)
   HGW110.Release
return(nil)   

function SendRecallLetter(oActivity, nCaseId, nObjectId)
   local cText1 := "", cText2, oCustomer
   if oActivity:numberOfMonthsRecallterm = 7
      cText1 := "First"
   elseif oActivity:numberOfMonthsRecallterm = 14
      cText1 := "Second"
   endif   
   oCustomer := Customers():Get(nObjectId, Customer():New(), "customer")
   cText2 := oCustomer:nameFirst + " " + oCustomer:namelast
   HGW110.Label_2.Value := cText1 + " recall Letter has been sent to " + cText2
   inkey(3)
return(nil)

function ApplyNewProduct(oActivity, nCaseId, dRundate)
   local txdate, oProduct
   if pcount() > 2
      txdate := dRundate
   else
      txdate := date()
   endif   
   oProduct := Product():New()
   oproduct := xml2obj(WfmLookupDossier(nCaseId))
   if txdate >= oProduct:txdate
      oProduct:Save(txdate, time(), userprofile:userid, txdate)
      WfmUpdateStatus("Update assortment", "Apply new product", nCaseId, "New product applied", "", "continue")
      HGW110.Label_2.Value := "New product " + oProduct:nameProduct
      inkey(3)
   endif
return(nil)   

function ApplyPricechange(oActivity, nCaseId, dRundate)
   local txdate, n, oPricechange, oProducttype, product
   if pcount() > 2
      txdate := dRundate
   else
      txdate := date()
   endif   
   oPricechange := Pricechange():New()
   oPricechange := xml2obj(WfmLookupDossier(nCaseId))
   if txdate >= oPricechange:startdate
      for n := 1 to len(oPricechange:producttypes)
         oProducttype := oPricechange:producttypes[n] 
         product := Products():QueryOnProductcode(oProducttype:productcode)
         if product:id > 0
            product:valuePrice := oProducttype:price
            product:Save(txdate, time(), userprofile:userid, txdate)
         else
            MsgInfo("Product not found, please contact your servicedesk (error PROD2)")
            return(nil)
         endif
      next     
      WfmUpdateStatus("Change price", "Apply pricechange", nCaseId, "Pricechange applied", "", "Continue")
      HGW110.Label_2.Value := "Price changed for product " + product:nameProduct
      inkey(3)
   endif
return(nil)   

function OnExit()
   OR0000.Release
return(nil)   

